sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=95
left=100
sizeHControl=0
sizeVControl=0
tile=1
caption="CSV-Export"
tileSpacing=10
End CompInit
Dim export_button as button
export_button = MakeComponent("button",form1)
CompInit export_button
proto="export_button"
caption="Export !"
sizeHControl=3
sizeVControl=3
default=1
visible=1
End CompInit
export_button.name="export_button"
Dim text1 as text
text1 = MakeComponent("text",form1)
CompInit text1
proto="text1"
width=400
End CompInit
text1.name="text1"
text1.visible=1
form1.name="form1"
form1.height=142
form1.width=421
Dim busy1 as busy
busy1 = MakeComponent("busy","app")
CompInit busy1
proto="busy1"
End CompInit
busy1.name="busy1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()

' Test fuer CSV-Export einer Array-Variablen

DIM test[5,3] AS string
	test[0,0] = "NullNull"
	test[0,1] = "NullEins"
	test[0,2] = "NullZwei"
	test[1,0] = "EinsNull"
	test[1,1] = "EinsEins"
	test[1,2] = "EinsZwei"
	test[2,0] = "ZweiNull"
	test[2,1] = "ZweiEins"
	test[2,2] = "ZweiZwei"
	test[3,0] = "DreiNull"
	test[3,1] = "DreiEins"
	test[3,2] = "DreiZwei"
	test[4,0] = "VierNull"
	test[4,1] = "VierEins"
	test[4,2] = "VierZwei"

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub export_button_pressed(self as button)
	CsvExport()
end sub

sub CsvExport()

busy1.Enter()

dim testfile as component
testfile = MakeComponent("file","top")
testfile.name = "exp-test.csv"

' x-Richtung: 0....2
' y-Richtung: 0....4

testfile.create()
testfile.size = 0
testfile.open()

dim cx as integer
dim cy as integer

dim dummystring as string

for cy = 0 to 4
	for cx = 0 to 2
		if cx < 2
			dummystring = dummystring + chr(34) + test[cy,cx] + chr(34) + ","
		else
			dummystring = dummystring + chr(34) + test[cy,cx] + chr(34)
		end if
	next cx
		'dummystring = dummystring + "\r" ' kein korrekter Ex-/Import
		dummystring = dummystring + "\r" + chr(34) ' \r = Zeilenumbruch
next cy

testfile.write(dummystring, len(dummystring))
testfile.close()
text1.text = dummystring

busy1.Leave()
MessageBox("Export","Export beendet, Datei: exp-test.csv.")

end sub

sub MessageBox(msgb_title as string, msgb_message as string)

	dim msgb_dialog as component
	msgb_dialog = MakeComponent("dialog", "app")
	msgb_dialog.proto ="msgb_dialog"
	msgb_dialog.caption = msgb_title
	msgb_dialog.sizeHControl=3
	msgb_dialog.sizeVControl=3

	dim msgb_group as component
	msgb_group = MakeComponent("group", msgb_dialog)
	msgb_group.proto = "msgb_group"
	msgb_group.look = 0
	msgb_group.sizeHControl=3
	msgb_group.sizeVControl=3
	msgb_group.tile = 1
	msgb_group.tileSpacing = 5
	msgb_group.left = 0
	msgb_group.top = 0
	msgb_group.tileHAlign = 0

   	dim msgb_text as component
	msgb_text = MakeComponent("label", msgb_group)
	msgb_text.proto = "msgb_text"
	msgb_text.caption = msgb_message

	dim msgb_btn as component
	msgb_btn = MakeComponent("button", msgb_group)
	msgb_btn.proto = "msgb_btn"
	msgb_btn.caption = "OK"
	msgb_btn.visible = 1
	msgb_btn.default = 1
	msgb_btn.closeDialog = 1

	msgb_group.visible = 1
	msgb_text.visible = 1
	msgb_dialog.visible = 1

end sub

