sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=197
left=120
sizeHControl=0
sizeVControl=0
caption="HTML Table Tool"
helpContext=""
helpFile="text"
End CompInit
Dim InputText as text
InputText = MakeComponent("text",form1)
CompInit InputText
proto="InputText"
left=10
top=62
height=132
width=440
End CompInit
InputText.name="InputText"
InputText.AppendString("Instructions\r")
InputText.AppendString("\r")
InputText.AppendString("* Select a table in another application.\r")
InputText.AppendString("* Then you MUST click here with the mouse.\r")
InputText.AppendString("* Click the Paste button.\r")
InputText.AppendString("* Select if the input data is delimited by tab or comma.")
InputText.visible=1
Dim OutputText as text
OutputText = MakeComponent("text",form1)
CompInit OutputText
proto="OutputText"
left=10
top=198
width=440
height=132
End CompInit
OutputText.name="OutputText"
OutputText.AppendString("Instructions \r")
OutputText.AppendString("\r")
OutputText.AppendString("* Select HTML Options if required then click Create HTML.\r")
OutputText.AppendString("* The HTML will appear in this window.\r")
OutputText.AppendString("* The HTML code has been copied to the clipboard.\r")
OutputText.AppendString("* To start again and view these instructions click Clear.")
OutputText.visible=1
Dim group1 as group
group1 = MakeComponent("group",form1)
CompInit group1
proto="group1"
caption="Delimiter"
left=471
top=64
height=60
width=100
look=1
tile=1
tileHAlign=2
visible=1
End CompInit
Dim Tabs as choice
Tabs = MakeComponent("choice",group1)
CompInit Tabs
proto="Tabs"
caption="Tabs"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
Tabs.name="Tabs"
Dim Comma as choice
Comma = MakeComponent("choice",group1)
CompInit Comma
proto="Comma"
caption="Comma"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Comma.name="Comma"
group1.name="group1"
Dim group2 as group
group2 = MakeComponent("group",form1)
CompInit group2
proto="group2"
caption=""
left=10
top=338
height=31
width=441
look=1
tile=1
tileSpacing=5
tileLayout=1
visible=1
End CompInit
Dim pasteButton as button
pasteButton = MakeComponent("button",group2)
CompInit pasteButton
proto="pasteButton"
caption="Paste"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
pasteButton.name="pasteButton"
Dim ClearButton as button
ClearButton = MakeComponent("button",group2)
CompInit ClearButton
proto="ClearButton"
caption="Clear"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
ClearButton.name="ClearButton"
Dim button4 as button
button4 = MakeComponent("button",group2)
CompInit button4
proto="button4"
caption="Create HTML"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
button4.name="button4"
Dim HelpButton as button
HelpButton = MakeComponent("button",group2)
CompInit HelpButton
proto="HelpButton"
caption="Help"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
HelpButton.name="HelpButton"
group2.name="group2"
Dim HTML_Opt as group
HTML_Opt = MakeComponent("group",form1)
CompInit HTML_Opt
proto="HTML_Opt"
caption="HTML Options"
left=470
top=206
height=120
width=100
look=1
tile=1
tileHAlign=2
visible=1
End CompInit
Dim Border as toggle
Border = MakeComponent("toggle",HTML_Opt)
CompInit Border
proto="Border"
caption="Border"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
Border.name="Border"
Dim Center as toggle
Center = MakeComponent("toggle",HTML_Opt)
CompInit Center
proto="Center"
caption="Center Table"
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
Center.name="Center"
Dim Spacepad as toggle
Spacepad = MakeComponent("toggle",HTML_Opt)
CompInit Spacepad
proto="Spacepad"
caption="Space Pad"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Spacepad.name="Spacepad"
Dim CellAlign as group
CellAlign = MakeComponent("group",HTML_Opt)
CompInit CellAlign
proto="CellAllign"
caption="Cell Align"
height=3
width=100
look=1
tile=1
tileHAlign=2
visible=1
End CompInit
Dim CellCenter as choice
CellCenter = MakeComponent("choice",CellAlign)
CompInit CellCenter
proto="CellCenter"
caption="Center"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
CellCenter.name="CellCenter"
Dim CellLeft as choice
CellLeft = MakeComponent("choice",CellAlign)
CompInit CellLeft
proto="CellLeft"
caption="Left"
sizeHControl=3
sizeVControl=0
height=15
status=1
visible=1
End CompInit
CellLeft.name="CellLeft"
Dim CellRight as choice
CellRight = MakeComponent("choice",CellAlign)
CompInit CellRight
proto="CellRight"
caption="Right"
visible=1
End CompInit
CellRight.name="CellRight"
CellAlign.name="CellAlign"
HTML_Opt.name="HTML_Opt"
Dim Exit_Button as button
Exit_Button = MakeComponent("button",form1)
CompInit Exit_Button
proto="Exit_Button"
caption="Exit"
sizeHControl=3
sizeVControl=3
left=391
top=120
End CompInit
Exit_Button.name="Exit_Button"
form1.name="form1"
form1.height=401
form1.width=601
form1.focus=InputText
Dim clipboard1 as clipboard
clipboard1 = MakeComponent("clipboard","app")
CompInit clipboard1
proto="clipboard1"
End CompInit
clipboard1.name="clipboard1"
Dim dialog1 as dialog
dialog1 = MakeComponent("dialog","app")
CompInit dialog1
proto="dialog1"
left=632
top=440
caption=""
End CompInit
Dim group5 as group
group5 = MakeComponent("group",dialog1)
CompInit group5
proto="group5"
caption=""
left=7
top=12
height=42
width=133
look=1
tile=1
tileLayout=1
visible=1
End CompInit
Dim AboutButton as choice
AboutButton = MakeComponent("choice",group5)
CompInit AboutButton
proto="AboutButton"
caption="Help About"
look=1
sizeHControl=3
sizeVControl=3
status=1
visible=1
End CompInit
AboutButton.name="AboutButton"
Dim ProghelpButton as choice
ProghelpButton = MakeComponent("choice",group5)
CompInit ProghelpButton
proto="ProghelpButton"
caption="Help On Program"
sizeHControl=3
sizeVControl=0
look=1
height=15
visible=1
End CompInit
ProghelpButton.name="ProghelpButton"
Dim HTMLHelp as choice
HTMLHelp = MakeComponent("choice",group5)
CompInit HTMLHelp
proto="HTMLHelp"
caption="HTML Table Tags"
sizeHControl=3
sizeVControl=3
look=1
visible=1
End CompInit
HTMLHelp.name="HTMLHelp"
Dim HTMLHelp2 as choice
HTMLHelp2 = MakeComponent("choice",group5)
CompInit HTMLHelp2
proto="HTMLHelp2"
caption="HTML Tag Attributes"
look=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
HTMLHelp2.name="HTMLHelp2"
group5.name="group5"
Dim HTMLtext as text
HTMLtext = MakeComponent("text",dialog1)
CompInit HTMLtext
proto="HTMLtext"
left=477
top=52
readOnly=1
height=23
width=7
End CompInit
HTMLtext.name="HTMLtext"
HTMLtext.AppendString("<TABLE ...></TABLE> \r")
HTMLtext.AppendString("This is the main wrapper for all the other table tags, & other table tags will be ignored if they aren't wrapped inside of a TABLE tag. A Border will be added if the BORDER attribute is specified. TABLE has an implied linebreak both before & after it. \r")
HTMLtext.AppendString("\r")
HTMLtext.AppendString("<TR ...></TR> \r")
HTMLtext.AppendString("This stands for table row. The number of rows in a table is exactly specified by how many TR tags are contained within it, regardless of cells that may attempt to use the ROWSPAN attribute to span into non-specified rows. TR can have both the ALIGN & VALIGN attributes, which if specified become the default alignments for all cells in this row. \r")
HTMLtext.AppendString("\r")
HTMLtext.AppendString("<TD ...></TD> \r")
HTMLtext.AppendString("This stands for table data, & specifies a standard table data cell. Table data cells must only appear within table rows. Each row need not have the same number of cells specified as short rows will be padded with blank cells on the right. A cell can contain any of the HTML tags normally present in the body of an HTML document. The default alignment of table data is ALIGN=left & VALIGN=middle. Overridden by any alignments specified in the containing TR tag, & those alignments in turn are overridden by any ALIGN or VALIGN attributes explicitly specified on this cell. By default lines inside of table cells can be broken up to fit within the overall cell width. \r")
HTMLtext.AppendString("\r")
HTMLtext.AppendString("<TH ...></TH> \r")
HTMLtext.AppendString("This stands for table header. Header cells are identical to data cells in all respects, with the exception that header cells are in a bold FONT, & have a default ALIGN=center. \r")
HTMLtext.AppendString("\r")
HTMLtext.AppendString("<CAPTION ...></CAPTION> \r")
HTMLtext.AppendString("This represents the caption for a table. CAPTION tags should appear inside the TABLE but not inside table rows or cells. The caption accepts an alignment attribute that defaults to ALIGN=top but can be explicitly set to ALIGN=bottom. Like table cells, any document body HTML can appear in a caption. Captions are always horizontally centered with respect to the table, & the may have their lines broken to fit within the width of the table. \r")
HTMLtext.AppendString("")
Dim AboutText as text
AboutText = MakeComponent("text",dialog1)
CompInit AboutText
proto="AboutText"
left=7
top=59
height=374
width=604
readOnly=1
maxChars=2000
maxLines=0
End CompInit
AboutText.name="AboutText"
AboutText.AppendString("HTML TABLE TOOL V 0.5 Beta 1\r")
AboutText.AppendString("\r")
AboutText.AppendString("Copyright April 1998 \r")
AboutText.AppendString("\r")
AboutText.AppendString("Written By Andy Moss\r")
AboutText.AppendString("\r")
AboutText.AppendString("This Program is an Initial Beta Version and can be used freely at your own risk but has no Warranty.\r")
AboutText.AppendString("\r")
AboutText.AppendString("If you find it useful please E-mail me and let me know :-) !\r")
AboutText.AppendString("\r")
AboutText.AppendString("For comments or suggestions please E-Mail :-\r")
AboutText.AppendString("andymoss@ndirect.co.uk\r")
AboutText.AppendString("")
AboutText.visible=1
Dim HTMLtext2 as text
HTMLtext2 = MakeComponent("text",dialog1)
CompInit HTMLtext2
proto="HTMLtext2"
left=443
top=10
width=1
height=1
End CompInit
HTMLtext2.name="HTMLtext2"
HTMLtext2.AppendString("BORDER \r")
HTMLtext2.AppendString("This attribute appears in the TABLE tag. If present, borders are drawn around all table cells. If absent, there are no borders, but by default space is left for borders, so the same table with and without the BORDER attribute will have the same width. \r")
HTMLtext2.AppendString("\r")
HTMLtext2.AppendString("ALIGN \r")
HTMLtext2.AppendString("If appearing inside a CAPTION it controls whether the caption appears above or below the table, and can have the values top or bottom, defaulting to top. \r")
HTMLtext2.AppendString("If appearing inside a TR, TH, or TD it controls whether text inside the table cell(s) is aligned to the left side of the cell, the right side of the cell, or centered within the cell. Values are left, center, and right. \r")
HTMLtext2.AppendString("\r")
HTMLtext2.AppendString("VALIGN \r")
HTMLtext2.AppendString("Appearing inside a TR, TH, or TD it controls whether text inside the table cell(s) is aligned to the top of the cell, the bottom of the cell, or vertically centered within the cell. It can also specify that all the cells in the row should be vertically aligned to the same baseline. Values are top, middle bottom, and baseline. \r")
HTMLtext2.AppendString("\r")
HTMLtext2.AppendString("NOWRAP \r")
HTMLtext2.AppendString("If this attribute appears in any table cell (TH or TD) it means the lines within this cell cannot be broken to fit the width of the cell. Be cautious in use of this attribute as it can result in excessively wide cells. \r")
HTMLtext2.AppendString("\r")
HTMLtext2.AppendString("COLSPAN \r")
HTMLtext2.AppendString("This attribute can appear in any table cell (TH or TD) and it specifies how many columns of the table this cell should span. The default COLSPAN for any cell is 1. \r")
HTMLtext2.AppendString("\r")
HTMLtext2.AppendString("ROWSPAN \r")
HTMLtext2.AppendString("This attribute can appear in any table cell (TH or TD) and it specifies how many rows of the table this cell should span. The default ROWSPAN for any cell is 1. A span that extends into rows that were never specified with a TR will be truncated. ")
Dim AboutText2 as text
AboutText2 = MakeComponent("text",dialog1)
CompInit AboutText2
proto="AboutText2"
left=580
top=7
width=1
height=1
maxChars=2000
maxLines=0
End CompInit
AboutText2.name="AboutText2"
AboutText2.AppendString("HTML TABLE TOOL V 0.5 Beta 1\r")
AboutText2.AppendString("\r")
AboutText2.AppendString("Copyright April 1998 \r")
AboutText2.AppendString("\r")
AboutText2.AppendString("Written By Andy Moss\r")
AboutText2.AppendString("\r")
AboutText2.AppendString("This Program is an Initial Beta Version and can be used freely at your own risk but has no Warranty.\r")
AboutText2.AppendString("\r")
AboutText2.AppendString("If you find it useful please E-mail me and let me know :-) !\r")
AboutText2.AppendString("\r")
AboutText2.AppendString("For comments or suggestions please E-Mail :-\r")
AboutText2.AppendString("andymoss@ndirect.co.uk")
Dim ProgText as text
ProgText = MakeComponent("text",dialog1)
CompInit ProgText
proto="ProgText"
left=385
top=253
End CompInit
ProgText.name="ProgText"
ProgText.AppendString("Marking up HTML Tables is a time consuming and error prone process.\r")
ProgText.AppendString("\r")
ProgText.AppendString("This Program is designed to take a table with Columns delimited by either Tabs or Commas and convert it into a fully marked up HTML Table.\r")
ProgText.AppendString("\r")
ProgText.AppendString("NewCalc/GeoCalc will produce a tab delimited input simply by selecting a range and copying it\r")
ProgText.AppendString("\r")
ProgText.AppendString("Newfile will produce a comma delimited output by using the export facility.\r")
ProgText.AppendString("\r")
ProgText.AppendString("Alternatively use the text file editor or NewWrite to produce a table with columns separated by tabs and rows by a carriage return.\r")
ProgText.AppendString("\r")
ProgText.AppendString("Simple follow the instructions on screen to produce a table ready to paste into your HTML source.\r")
ProgText.AppendString("\r")
ProgText.AppendString("Options\r")
ProgText.AppendString("Delimiter - Select Tabs if your data is delimited by tabs (eg. a paste from Newcalc) or commas if delimited by commas (eg. an export from Newfile )\r")
ProgText.AppendString("\r")
ProgText.AppendString("HTML Options\r")
ProgText.AppendString("Border - add lines around the cells\r")
ProgText.AppendString("Center - Center the whole table\r")
ProgText.AppendString("Space Pad - Add a space in each cell useful for compatability with non table browsers like Skipper\r")
ProgText.AppendString("Cell Align - Position of data within the cell")
Dim HelpOK as button
HelpOK = MakeComponent("button",dialog1)
CompInit HelpOK
proto="HelpOK"
caption="Exit Help"
left=474
top=253
sizeHControl=3
closeDialog=1
sizeVControl=3
visible=1
End CompInit
HelpOK.name="HelpOK"
Dim label1 as label
label1 = MakeComponent("label",dialog1)
CompInit label1
proto="label1"
caption="HTML Table Tool V1.0"
left=28
top=180
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
label1.name="label1"
dialog1.name="dialog1"
dialog1.width=630
dialog1.height=470
Dim busy1 as busy
busy1 = MakeComponent("busy","app")
CompInit busy1
proto="busy1"
End CompInit
busy1.name="busy1"
Dim sound1 as sound
sound1 = MakeComponent("sound","app")
CompInit sound1
proto="sound1"
End CompInit
sound1.name="sound1"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

	dim cliptxt as string
	dim outtxt as string

InputText.color = DARK_PURPLE
InputText.font = "URW Mono"
InputText.fontSize = 12

OutputText.color = DARK_PURPLE
OutputText.font = "URW Mono"
OutputText.fontSize = 12



end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub cutButton_pressed(self as button)
	InputText.text=""
	OutputText.text=""
end sub

sub copyButton_pressed(self as button)
	clipboard1.SetItem(outtxt)
end sub

sub pasteButton_pressed(self as button)
dim clipvalid as integer
dim errmsg as string
	
	clipvalid = clipboard1.QueryItem("string")
	if clipvalid = 0 then
	sound1.StandardSound(1)
	errmsg="No valid selection on clipboard" + "\r" + "\r" + \
	"Copy a selection from another application & try again"  + "\r" + "\r" + \
	"This message appears when either nothing or a graphic is on the clipboard"

	InputText.text=errmsg
	else

		cliptxt = clipboard1.GetItem("string")
		if len(cliptxt) > 1999 then
		InputText.text=mid(cliptxt,1,1985) + "... <Truncated>"
		else
		InputText.text=cliptxt
		end if	
	end if										
end sub

function table(input as string) as string

dim counter as integer
dim charter as string
dim next_charter as string
dim no_cols as integer
dim nul_rec as integer
dim max_cols as integer
dim row_no_cols as integer
dim delim_char as integer
dim cell_align as string 

if Tabs.status then
delim_char = 9
else
if Comma.status
delim_char = 44
end if
end if

rem determine the maximum number of columns

rem counter = 1
rem max_cols=1
rem row_no_cols=0
rem for counter = 1 to len(input)
rem	charter = mid(input, counter, 1)
	
rem	if asc(charter) = delim_char then
rem		row_no_cols = row_no_cols + 1
rem	else
rem	if asc(charter) = 13 then
rem		row_no_cols = row_no_cols + 1
rem		if row_no_cols > max_cols then
rem			max_cols = row_no_cols
rem		end if
rem 		row_no_cols = 0
rem	else
rem	if	counter = len(input) then
rem		row_no_cols = row_no_cols + 1
rem		if row_no_cols > max_cols then
rem			max_cols = row_no_cols
rem		end if
rem 		row_no_cols = 0
rem	end if
rem	end if
rem	end if

rem next counter

rem main loop

charter = "\r"

if Center.status then
table = table + "<CENTER>"+charter
end if

if Border.status then
table = table + "<TABLE BORDER=1>"+charter
else
table = table + "<TABLE>"+charter
end if

cell_align=""
if CellRight.status then
cell_align= " ALIGN=RIGHT"
else
if CellCenter.status then
cell_align= " ALIGN=CENTER"
else
if CellLeft.status then
cell_align= " ALIGN=LEFT"
end if
end if
end if



table = table + "<TR" + cell_align +"><TD>"

counter = 1
for counter = 1 to len(input)
	charter = mid(input, counter, 1)

rem remove delimiters off end of lines

	if asc(charter) = delim_char then	
		next_charter = mid(input, counter + 1, 1)
		If asc(next_charter) = 13 then
		  counter = counter + 1
		  charter = mid(input, counter, 1)
	    end if
		if counter  = len(input) then
		  charter = ""
	    end if
	end if

rem main section 

	if asc(charter) = delim_char then
		if nul_rec = 1
			table = table + "&nbsp;"
		end if
		if Spacepad.status then
		table = table + "&nbsp;"
		end if
		table = table + "</TD><TD>"
		nul_rec = 1
	else
	if asc(charter) = 13 then
		if nul_rec = 1
			table = table + "&nbsp;"
		end if
		if Spacepad.status then
		table = table + "&nbsp;"
		end if
		table = table + "</TD></TR>" + "\r" + "<TR" + cell_align +"><TD>"
		nul_rec = 1
	else
	if	counter = len(input) then
		table = table + charter
		if Spacepad.status then
		table = table + "&nbsp;"
		end if
		table = table + "</TD></TR>"
	else
		nul_rec=0
		table = table + charter
	end if
	end if
	end if


next counter

charter = "\r"

table = table + charter + "</TABLE>"

if Center.status then
table = table + charter + "</CENTER>"
end if

end function

sub button4_pressed(self as button)

	busy1.Enter()
	outtxt= table(cliptxt)
	busy1.Leave()

	if len(outtxt) > 1999 then
		OutputText.text=mid(outtxt,1,1985) + "... <Truncated>"
	else
		OutputText.text=outtxt
	end if	

	clipboard1.SetItem(outtxt)



end sub

sub Exit_Button_pressed(self as button)

end sub

function form1_activeChanged(self as form, gain as integer)

if gain THEN
	self.focus=InputText
end if
end function

sub ClearButton_pressed(self as button)
OutputText.text=""
InputText.text=""
InputText.text="Instructions" + "\r" + "\r" + \
"* Select a table in another application." + "\r" + \
"* Then you MUST click here with the mouse." + "\r" +\
"* Click the Paste button." + "\r" + \
"* Select if the input data is delimited by tab or comma."

OutputText.text="Instructions " + "\r\r" + \
"* Select HTML Options if required then click Create HTML." + \
"\r" + "* The HTML will appear in this window." + "\r" + \
"* The HTML code has been copied to the clipboard." + \
"\r" + "* To start again and view these instructions click Clear." 
end sub

sub HelpButton_pressed(self as button)
dialog1.visible = 1
end sub

sub AboutButton_changed(self as choice)
AboutText.text=AboutText2.text
end sub

sub ProghelpButton_changed(self as choice)
AboutText.text=ProgText.text

end sub

sub HTMLHelp_changed(self as choice)
AboutText.text=HTMLtext.text
AboutText.FirstVisibleLine=0
end sub

sub HTMLHelp2_pressed(self as button)
AboutText.text=HTMLtext2.text
end sub

sub HTMLHelp2_changed(self as choice)
AboutText.text=HTMLtext2.text
end sub

function form1_aboutToOpen(self as form)
dim cliptxt as string
end function

